Index: trunk/BNC/src/bnchelp.html
===================================================================
--- trunk/BNC/src/bnchelp.html	(revision 10074)
+++ trunk/BNC/src/bnchelp.html	(revision 10084)
@@ -3907,9 +3907,9 @@
 
 <pre><p style="font-family:Monospace">
-%=TRO 2.00 BKG 22:322:00000 BKG 22:322:00000 22:322:03599 P 03600 0  T
+%=TRO 2.00 BKG 23:152:00000 BKG 23:152:00000 23:152:03599 P 03600 0  T
 +FILE/REFERENCE
  DESCRIPTION        BNC generated SINEX TRO file
  OUTPUT             Total Troposphere Zenith Path Delay Product
- SOFTWARE           BNC 2.13
+ SOFTWARE           BNC 2.13.0
  INPUT              Observations: WTZR00DEU, SSR corrections: SSRA00BKG1
 -FILE/REFERENCE
@@ -3922,10 +3922,10 @@
 +SITE/RECEIVER
 *SITE      PT SOLN T DATA_START__ DATA_END____ DESCRIPTION_________ S/N__ FIRMWARE___
- WTZR00DEU  A    1 P 22:322:00000 22:322:03599           LEICA GR25 ----- -----------
+ WTZR00DEU  A    1 P 23:152:00000 23:152:03599           LEICA GR25 ----- -----------
 -SITE/RECEIVER
 
 +SITE/ANTENNA
 *SITE      PT SOLN T DATA_START__ DATA_END____ DESCRIPTION_________ S/N__
- WTZR00DEU  A    1 P 22:322:00000 22:322:03599 LEIAR25.R3      LEIT -----
+ WTZR00DEU  A    1 P 23:152:00000 23:152:03599 LEIAR25.R3      LEIT -----
 -SITE/ANTENNA
 
@@ -3933,5 +3933,5 @@
 *                           UP____ NORTH_ EAST__ UP____ NORTH_ EAST__
 *DESCRIPTION_________ S/N__ L1->ARP(m)__________ L2->ARP(m)__________ AZ_EL____
- LEIAR25.R3      LEIT ----- +.1617 +.0005 +.0001 +.1579 +.0001 -.0007 ---------
+ LEIAR25.R3      LEIT ----- +.1610 -.0001 +.0009 +.1578 -.0004 +.0001 ---------
 -SITE/GPS_PHASE_CENTER
 
@@ -3939,5 +3939,5 @@
 *                           UP____ NORTH_ EAST__ UP____ NORTH_ EAST__
 *DESCRIPTION_________ S/N__ L1->ARP(m)__________ L2->ARP(m)__________ AZ_EL____
- LEIAR25.R3      LEIT ----- +.1617 +.0005 +.0001 +.1579 +.0001 -.0007 ---------
+ LEIAR25.R3      LEIT ----- +.1598 +.0000 +.0009 +.1554 -.0006 -.0002 ---------
 -SITE/GLONASS_PHASE_CENTER
 
@@ -3945,5 +3945,5 @@
 *                           UP____ NORTH_ EAST__ UP____ NORTH_ EAST__
 *DESCRIPTION_________ S/N__ L1->ARP(m)__________ L2->ARP(m)__________ AZ_EL____
- LEIAR25.R3      LEIT ----- ------ ------ ------ ------ ------ ------
+ LEIAR25.R3      LEIT ----- +.1610 -.0001 +.0009 +.1626 -.0006 -.0001 ---------
 -SITE/GALILEO_PHASE_CENTER
 
@@ -3951,5 +3951,5 @@
 *                                             UP______ NORTH___ EAST____
 *SITE      PT SOLN T DATA_START__ DATA_END____ AXE ARP->BENCHMARK(M)_________
- WTZR00DEU  A    1 P 22:322:00000 22:322:03599 UNE   0.0710   0.0000   0.0000
+ WTZR00DEU  A    1 P 23:152:00000 23:152:03599 UNE   0.0710   0.0000   0.0000
 -SITE/ECCENTRICITY
 
@@ -3964,4 +3964,5 @@
  SAMPLING TROP                                      1
  ELEVATION CUTOFF ANGLE                             7
+ OCEAN TIDE LOADING MODEL      BNC.BLQ
  TROP MAPPING FUNCTION         Saastamoinen
  SOLUTION_FIELDS_1             TROTOT STDEV
@@ -3970,16 +3971,28 @@
 +TROP/SOLUTION
 *SITE      EPOCH_______ TROTOT STDEV
- WTZR00DEU 22:322:78171 2183.5 100.0
- WTZR00DEU 22:322:78172 2183.5 100.0
- WTZR00DEU 22:322:78173 2183.7  99.9
- WTZR00DEU 22:322:78174 2183.8  99.9
- WTZR00DEU 22:322:78175 2184.0  99.8
- WTZR00DEU 22:322:78176 2184.2  99.8
- WTZR00DEU 22:322:78177 2184.4  99.7
- WTZR00DEU 22:322:78178 2184.6  99.7
- WTZR00DEU 22:322:78179 2184.8  99.6
- WTZR00DEU 22:322:78180 2185.0  99.6
- WTZR00DEU 22:322:78181 2185.4  99.5
-...
+ WTZR00DEU 23:152:39051 2183.7 100.0
+ WTZR00DEU 23:152:39052 2183.8 100.0
+ WTZR00DEU 23:152:39053 2184.1  99.9
+ WTZR00DEU 23:152:39054 2184.5  99.9
+ WTZR00DEU 23:152:39055 2184.8  99.8
+ WTZR00DEU 23:152:39056 2184.9  99.8
+ WTZR00DEU 23:152:39057 2185.2  99.7
+ WTZR00DEU 23:152:39058 2185.3  99.6
+ WTZR00DEU 23:152:39059 2185.7  99.6
+ WTZR00DEU 23:152:39060 2186.0  99.5
+ WTZR00DEU 23:152:39061 2186.5  99.4
+ WTZR00DEU 23:152:39062 2187.6  99.3
+ WTZR00DEU 23:152:39063 2188.2  99.1
+ WTZR00DEU 23:152:39064 2189.4  99.0
+ WTZR00DEU 23:152:39065 2189.7  98.8
+ WTZR00DEU 23:152:39066 2190.5  98.6
+ WTZR00DEU 23:152:39067 2191.5  98.5
+ WTZR00DEU 23:152:39068 2192.0  98.2
+ WTZR00DEU 23:152:39069 2193.0  98.0
+ WTZR00DEU 23:152:39070 2194.0  97.7
+ WTZR00DEU 23:152:39071 2195.0  97.5
+ WTZR00DEU 23:152:39072 2195.6  97.2
+ WTZR00DEU 23:152:39073 2196.5  96.8
+ WTZR00DEU 23:152:39074 2197.7  96.5
 -TROP/SOLUTION
 %=ENDTROP
@@ -4007,5 +4020,5 @@
 A result for examle is:
 <pre>
-  BKG1DEMRTS_20223222100_01H_01S_WTZR00DEU_TRO.TRO
+  BKG1DEMRTS_20231521000_01H_01S_WTZR00DEU_TRO.TRO
 </pre>
 