Index: /trunk/BNC/src/bnccore.cpp
===================================================================
--- /trunk/BNC/src/bnccore.cpp	(revision 10090)
+++ /trunk/BNC/src/bnccore.cpp	(revision 10091)
@@ -226,4 +226,5 @@
 #endif
   printEphHeader();
+  //printEphHeader(eph->receptStaID());
   printEph(*eph, (ircPut == success));
   return success;
@@ -272,8 +273,9 @@
 // Print Header of the output File(s)
 ////////////////////////////////////////////////////////////////////////////
-void t_bncCore::printEphHeader() {
+void t_bncCore::printEphHeader(QString receptStaID) {
 
   bncSettings settings;
   QStringList comments;
+  bool separateFiles = false;// Qt::CheckState(settings.value("ephFilePerStation").toInt());
 
   QListIterator<QString> it(settings.value("mountPoints").toStringList());
@@ -284,7 +286,9 @@
     QUrl url(hlp[0]);
     QString decoder = hlp[1];
-    comments.append("Source: " + decoder +
-                    " " + QUrl::toAce(url.host()) +
-                    "/" + url.path().mid(1).toLatin1());
+    if (!separateFiles) {
+      comments.append("Source: " + decoder +
+                      " " + QUrl::toAce(url.host()) +
+                      "/" + url.path().mid(1).toLatin1());
+    }
   }
 
@@ -311,5 +315,8 @@
     QDateTime datTim = currentDateAndTimeGPS();
 
-    QString ephFileNameGPS = _ephPath + "BRDC";
+    QString ephFileNameGPS = _ephPath; // + "BRDC";
+
+    (separateFiles) ?  ephFileNameGPS += receptStaID.left(4) :
+                       ephFileNameGPS += "BRDC";
 
     QString hlpStr = bncRinex::nextEpochStr(datTim,
@@ -320,4 +327,9 @@
       QString monNum = "0";
       QString recNum = "0";
+      if (separateFiles && receptStaID.size() >= 9) {
+        monNum = receptStaID.mid(4,1);
+        recNum = receptStaID.mid(5,1);
+        country = receptStaID.mid(6,3);
+      }
       ephFileNameGPS += QString("%1").arg(monNum, 1, 10) +
                         QString("%1").arg(recNum, 1, 10) +
Index: /trunk/BNC/src/bnccore.h
===================================================================
--- /trunk/BNC/src/bnccore.h	(revision 10090)
+++ /trunk/BNC/src/bnccore.h	(revision 10091)
@@ -115,4 +115,5 @@
   t_irc checkPrintEph(t_eph* eph);
   void  printEphHeader();
+  //void  printEphHeader(QString receptStaID);
   void  printEph(const t_eph& eph, bool printFile);
   void  printOutputEph(bool printFile, QTextStream* stream,
Index: /trunk/BNC/src/bncutils.cpp
===================================================================
--- /trunk/BNC/src/bncutils.cpp	(revision 10090)
+++ /trunk/BNC/src/bncutils.cpp	(revision 10091)
@@ -916,6 +916,8 @@
 int indexFromAccuracy(double accuracy, t_eph::e_type type) {
 
-  if (type == t_eph::GPS || type == t_eph::BDS || type == t_eph::SBAS
-      || type == t_eph::QZSS) {
+  if (type == t_eph::GPS ||
+      type == t_eph::BDS ||
+      type == t_eph::SBAS ||
+      type == t_eph::QZSS) {
 
     if (accuracy <= 2.40) {
Index: /trunk/BNC/src/bncwindow.cpp
===================================================================
--- /trunk/BNC/src/bncwindow.cpp	(revision 10090)
+++ /trunk/BNC/src/bncwindow.cpp	(revision 10091)
@@ -280,4 +280,6 @@
     _ephVersComboBox->setCurrentIndex(jk);
   }
+  //_ephFilePerStation = new QCheckBox();
+  //_ephFilePerStation->setCheckState(Qt::CheckState(settings.value("ephFilePerStation").toInt()));
 
   connect(_ephOutPortLineEdit, SIGNAL(textChanged(const QString &)),
@@ -839,4 +841,7 @@
   eLayout->addWidget(_ephVersComboBox,                            4, 1);
   eLayout->setRowStretch(5, 999);
+  //eLayout->addWidget(new QLabel("File per Station"),              5, 0);
+  //eLayout->addWidget(_ephFilePerStation,                          5, 1);
+  //eLayout->setRowStretch(6, 999);
 
   egroup->setLayout(eLayout);
@@ -1399,4 +1404,5 @@
   _ephOutPortLineEdit->setWhatsThis(tr("<p>BNC can produce ephemeris data in RINEX Navigation ASCII format on your local host through an IP port.</p><p>Specify a port number here to activate this function. <i>[key: ephOutPort]</i></p>"));
   _ephVersComboBox->setWhatsThis(tr("<p>Select the format for RINEX Navigation files. <i>[key: ephVersion]</i></p>"));
+  //_ephFilePerStation->setWhatsThis(tr("<p>By default, all received Broadcast Ephemeris data will be stored within one File. Thick 'File per Stations' to get separate files per station/mountpoint. <i>[key: ephFilePerStation]</i></p>"));
 
   // WhatsThis, RINEX Editing & QC
@@ -1611,4 +1617,5 @@
   delete _rnxV2Priority;
   delete _ephPathLineEdit;
+  //delete _ephFilePerStation;
   delete _ephIntrComboBox;
   delete _ephOutPortLineEdit;
@@ -2081,4 +2088,5 @@
   settings.setValue("ephOutPort",    _ephOutPortLineEdit->text());
   settings.setValue("ephVersion",    _ephVersComboBox->currentText());
+  //settings.setValue("ephFilePerStation", _ephFilePerStation->checkState());
 // Broadcast Corrections
   settings.setValue("corrPath",    _corrPathLineEdit->text());
@@ -2598,4 +2606,6 @@
     enableWidget(enable, _ephIntrComboBox);
     enableWidget(enable, _ephVersComboBox);
+    //enableWidget(enable, _ephVersComboBox);
+    //enableWidget(enable, _ephFilePerStation);
   }
 
Index: /trunk/BNC/src/bncwindow.h
===================================================================
--- /trunk/BNC/src/bncwindow.h	(revision 10090)
+++ /trunk/BNC/src/bncwindow.h	(revision 10091)
@@ -167,4 +167,5 @@
     QLineEdit* _rnxV2Priority;
     QComboBox* _ephVersComboBox;
+    //QCheckBox* _ephFilePerStation;
     QCheckBox* _rnxFileCheckBox;
     QLineEdit* _rnxScrpLineEdit;