Index: /trunk/BNC/src/bnchelp.html
===================================================================
--- /trunk/BNC/src/bnchelp.html	(revision 10121)
+++ /trunk/BNC/src/bnchelp.html	(revision 10122)
@@ -2398,32 +2398,24 @@
 !  Epoch                PRN  radial   along   out        clk    clkRed   iPRN
 ! ----------------------------------------------------------------------------
-2022-08-29_08:01:30.000 G01  0.0297 -0.0526 -0.0198    -0.0005 -0.0301     1
-2022-08-29_08:01:30.000 G02  0.0225 -0.0179  0.0055     0.0054 -0.0171     2
-2022-08-29_08:01:30.000 G03  0.0210 -0.0387 -0.0153     0.0025 -0.0185     3
-2022-08-29_08:01:30.000 G06  0.0650  0.0599 -0.0260    -0.0074 -0.0724     6
-2022-08-29_08:01:30.000 G07  0.0112  0.0774  0.0331    -0.0021 -0.0133     7
-2022-08-29_08:01:30.000 G08  0.0241  0.0725  0.0009    -0.0008 -0.0248     8
-2022-08-29_08:01:30.000 G09 -0.0145  0.0669  0.0069     0.0051  0.0196     9
-2022-08-29_08:01:30.000 G11  0.0375  0.0650 -0.0080    -0.0094 -0.0469    11
-2022-08-29_08:01:30.000 G12  0.0634  0.0229 -0.0003     0.0078 -0.0556    12
-2022-08-29_08:01:30.000 G13  0.0163  0.0551  0.0904     0.0010 -0.0153    13
-2022-08-29_08:01:30.000 G14  0.0365  0.0646 -0.0398     0.0034 -0.0332    14
-2022-08-29_08:01:30.000 G15  0.0175  0.0892  0.0512    -0.0032 -0.0207    15
-2022-08-29_08:01:30.000 G16  0.0453  0.0408  0.0346    -0.0029 -0.0483    16
-2022-08-29_08:01:30.000 G17  0.0381 -0.0064 -0.0701     0.0020 -0.0362    17
-2022-08-29_08:01:30.000 G18 -0.0886  0.0031  0.0721    -0.0055  0.0831    18
-2022-08-29_08:01:30.000 G19  0.0310 -0.0190 -0.0264    -0.0000 -0.0311    19
-2022-08-29_08:01:30.000 G20  0.0199  0.0308  0.0476     0.0106 -0.0093    20
-2022-08-29_08:01:30.000 G21  0.0163  0.0079 -0.0464     0.0047 -0.0116    21
-2022-08-29_08:01:30.000 G22  0.0471  0.0173 -0.0315    -0.0023 -0.0494    22
-2022-08-29_08:01:30.000 G23 -0.0354 -0.0042  0.0247    -0.0035  0.0319    23
-2022-08-29_08:01:30.000 G24  0.0110  0.0030 -0.0323     0.0112  0.0002    24
-2022-08-29_08:01:30.000 G25  0.0037  0.0712 -0.0175    -0.0019 -0.0056    25
-2022-08-29_08:01:30.000 G26  0.0421 -0.0002  0.0511    -0.0009 -0.0430    26
-2022-08-29_08:01:30.000 G27  0.0164  0.1203  0.0347    -0.0041 -0.0205    27
-2022-08-29_08:01:30.000 G29 -0.0093  0.0141  0.0570     0.0095  0.0188    29
-2022-08-29_08:01:30.000 G30  0.0199  0.0805  0.0529    -0.0074 -0.0273    30
-2022-08-29_08:01:30.000 G31  0.0336 -0.0079 -0.0281    -0.0132 -0.0468    31
-2022-08-29_08:01:30.000 G32 -0.0185 -0.0200 -0.0103     0.0019  0.0205    32
+..
+2022-08-29_08:01:30.000 E02 -0.0023  0.1159 -0.0047     0.0187  0.0210    60
+2022-08-29_08:01:30.000 E03 -0.0567 -0.0411  0.0146    -0.0093  0.0474    61
+2022-08-29_08:01:30.000 E04  0.0695 -0.0406  0.0880    -0.0219 -0.0914    62
+2022-08-29_08:01:30.000 E05 -0.1042  0.1161 -0.0503    -0.0101  0.0942    63
+2022-08-29_08:01:30.000 E07  0.0354  0.0384 -0.0346     0.0134 -0.0219    65
+2022-08-29_08:01:30.000 E08 -0.0312  0.0312 -0.0481     0.0130  0.0442    66
+2022-08-29_08:01:30.000 E09 -0.0548  0.1941  0.0263    -0.0113  0.0436    67
+2022-08-29_08:01:30.000 E12  0.0402 -0.0023  0.0012    -0.0051 -0.0454    70
+2022-08-29_08:01:30.000 E13  0.0420 -0.0608 -0.0525    -0.0006 -0.0427    71
+2022-08-29_08:01:30.000 E15  0.0478  0.0348 -0.0353    -0.0122 -0.0600    73
+2022-08-29_08:01:30.000 E21  0.0639  0.0033  0.0292    -0.0167 -0.0806    79
+2022-08-29_08:01:30.000 E24  0.0900 -0.1113 -0.0385     0.0047 -0.0853    82
+2022-08-29_08:01:30.000 E25  0.0106  0.0340 -0.0564     0.0023 -0.0083    83
+2022-08-29_08:01:30.000 E26  0.0598  0.0506 -0.0983    -0.0011 -0.0609    84
+2022-08-29_08:01:30.000 E27  0.0763 -0.0972 -0.0480     0.0041 -0.0722    85
+2022-08-29_08:01:30.000 E30  0.0385  0.0266  0.0028     0.0092 -0.0293    88
+2022-08-29_08:01:30.000 E31  0.1017 -0.1834 -0.0211     0.0021 -0.0997    89
+2022-08-29_08:01:30.000 E33  0.0827  0.0385 -0.0741    -0.0060 -0.0887    91
+2022-08-29_08:01:30.000 E36  0.0099 -0.0769  0.0384     0.0269  0.0170    94
 ..
 !
@@ -2434,32 +2426,24 @@
 !              [mm]       [mm]        [mm]      [mm]      [-]      [ns]        [ns]        [ns]      [-]     [ns]
 ! -----------------------------------------------------------------------------------------------------------------
-!     G01       49.4       90.1        4.0      102.8     165       0.01       0.16       0.16       165     -2.71
-!     G02       39.8       34.2        6.2       52.8     165       0.01       0.13       0.13       165      4.13
-!     G03       27.8       57.7       12.8       65.3     165       0.01       0.09       0.09       165     -2.18
-!     G06       61.8       50.7       22.2       82.9     165       0.01       0.21       0.21       165     -2.70
-!     G07       22.2       80.3       31.7       89.2     165       0.01       0.07       0.07       165     -1.26
-!     G08       18.8      102.1       12.7      104.6     165       0.01       0.06       0.06       165      1.17
-!     G09        9.8       87.2        5.6       87.9     165       0.01       0.03       0.03       165      0.21
-!     G11       54.8       65.5        6.9       85.6     165       0.03       0.18       0.18       165     -1.93
-!     G12       64.4       48.2        7.3       80.8     165       0.02       0.21       0.21       165     -1.45
-!     G13       17.1       45.9       88.8      101.4     165       0.01       0.06       0.06       165     -0.67
-!     G14       34.9       79.4       32.6       92.7     165       0.01       0.12       0.12       165     -2.07
-!     G15       33.4       38.1       45.0       67.8     165       0.01       0.11       0.11       165     -2.19
-!     G16       50.0       67.9       51.2       98.7     165       0.01       0.17       0.17       165      3.27
-!     G17       44.1       12.0       73.8       86.8     165       0.01       0.15       0.15       165     -1.67
-!     G18       78.7       15.0       65.4      103.4     165       0.01       0.26       0.26       165     -2.37
-!     G19       29.1       12.7       38.2       49.7     165       0.01       0.10       0.10       165      6.27
-!     G20       19.0       25.2       33.4       45.9     165       0.02       0.06       0.06       165      5.58
-!     G21        8.6       13.3       44.5       47.3     165       0.01       0.03       0.03       165      5.40
-!     G22       53.5       18.3       29.0       63.5     165       0.01       0.18       0.18       165      1.54
-!     G23       29.8       35.8       16.1       49.2     165       0.01       0.10       0.10       165     -1.84
-!     G24       13.4       20.2       28.4       37.3     165       0.02       0.04       0.04       165     -2.67
-!     G25        9.2       88.4       28.0       93.2     165       0.02       0.04       0.04       165      1.68
-!     G26       45.2       33.4       60.5       82.5     165       0.02       0.15       0.15       165      0.36
-!     G27       22.4      128.4       39.9      136.3     165       0.01       0.07       0.07       165      0.59
-!     G29       17.2       42.3       59.7       75.1     165       0.02       0.06       0.06       165     -2.56
-!     G30       19.9       91.7       61.2      112.0     165       0.01       0.07       0.07       165      2.15
-!     G31       30.3       20.1       39.4       53.6     165       0.04       0.11       0.11       165     -1.97
-!     G32       16.7       28.9        8.2       34.4     165       0.01       0.06       0.06       165     -2.11
+..
+!     E02        7.2      116.0       26.7      119.2     165       0.04       0.05       0.05       165     -0.12
+!     E03       61.0       38.7       15.1       73.8     165       0.03       0.21       0.03       165     -0.13
+!     E04       83.0       61.9       81.9      132.0     165       0.04       0.28       0.02       165      0.22
+!     E05       96.6      119.3       41.8      159.1     165       0.02       0.32       0.01       165     -0.02
+!     E07       29.6       30.9       38.9       57.8     165       0.03       0.10       0.02       165     -0.30
+!     E08       37.1       19.3       42.4       59.5     165       0.03       0.12       0.02       165     -0.34
+!     E09       43.6      174.4       42.2      184.6     165       0.01       0.14       0.01       165     -0.10
+!     E12       49.0        3.3       10.7       50.2     165       0.01       0.16       0.01       165     -0.39
+!     E13       33.6       39.3       66.1       83.9     165       0.02       0.11       0.03       165     -0.23
+!     E15       54.8       27.3       37.5       71.8     165       0.02       0.18       0.01       165      0.18
+!     E21       66.7       11.6       30.1       74.2     165       0.03       0.22       0.02       165     -0.13
+!     E24       91.3      110.1       33.2      146.9     165       0.02       0.30       0.02       165      0.32
+!     E25        9.9       41.2       62.8       75.8     165       0.01       0.03       0.01       165      0.27
+!     E26       62.1       51.6       94.6      124.4     165       0.01       0.21       0.01       165      0.10
+!     E27       73.4       84.1       52.2      123.2     165       0.02       0.24       0.01       165      0.34
+!     E30       38.2       38.0        7.2       54.4     165       0.02       0.13       0.01       165      0.23
+!     E31       93.7      170.0       23.4      195.5     165       0.03       0.31       0.04       165      0.37
+!     E33       92.6       34.0       65.4      118.4     165       0.01       0.31       0.01       165      0.00
+!     E36        5.9       63.0       45.6       78.0     165       0.03       0.02       0.02       165     -0.26
 ..
 !